; Button
; A push button with rounded corners.
;
; Functions:
; 1. guiDrawButton			Checks the BU_Showing bit and either displays or clears button accordingly
; 2. guiShowButton			Sets the BU_Showing bit then calls guiDrawButton
; 3. guiHideButton			Resets the BU_Showing bit then calls guiDrawButton
;
; Comments:
;

BU_BigFont		equ	0
BU_Inverse		equ	1
BU_Showing		equ	2

guiShowButton:
 ld de,4
 add hl,de
 set BU_Showing,(hl)
 sbc hl,de
 jr guiDrawButton

guiHideButton:
 ld de,4
 add hl,de
 res BU_Showing,(hl)
 sbc hl,de

guiDrawButton:
 res plotLoc,(iy+plotFlags)
 res bufferonly,(iy+plotflag3)
 push hl
 pop ix
 ld e,(hl)
 inc hl
 ld d,(hl)
 inc hl
 ld a,(hl)
 inc hl
 ld h,(hl)
 ld l,a
 add hl,de
 ex de,hl
 bit BU_Showing,(ix+4)
 jp z,guiEraseButton
 push ix
 push hl
 push de
 B_CALL _drawrectborderc
 pop de
 pop hl
 pop ix
 bit BU_Inverse,(ix+4)
 jr z,guiDrawButtonNoInvert
 push ix
 B_CALL _invertrect
 pop ix
guiDrawButtonNoInvert:
 ld a,(ix+1)
 ld b,(ix)
 xor 3fh
 ld c,a
 ld d,2
 B_CALL _ipoint
 inc b
 B_CALL _ipoint
 dec c
 B_CALL _ipoint
 dec b
 B_CALL _ipoint
 ld a,(ix+1)
 add a,(ix+3)
 ld b,(ix)
 xor 3fh
 ld c,a
 ld d,2
 B_CALL _ipoint
 inc b
 B_CALL _ipoint
 inc c
 B_CALL _ipoint
 dec b
 B_CALL _ipoint
 ld a,(ix+1)
 xor 3fh
 ld c,a
 ld a,(ix)
 add a,(ix+2)
 ld b,a
 ld d,2
 B_CALL _ipoint
 dec b
 B_CALL _ipoint
 dec c
 B_CALL _ipoint
 inc b
 B_CALL _ipoint
 ld a,(ix+1)
 add a,(ix+3)
 xor 3fh
 ld c,a
 ld a,(ix)
 add a,(ix+2)
 ld b,a
 ld d,2
 B_CALL _ipoint
 dec b
 B_CALL _ipoint
 inc c
 B_CALL _ipoint
 inc b
 B_CALL _ipoint
 ld a,(ix+2)
 srl a
 inc a
 add a,(ix)
 ld l,a
 ld a,(ix+3)
 sra a
 add a,(ix+1)
 sub 3
 res fracDrawLFont,(iy+fontFlags)
 bit BU_BigFont,(ix+4)
 jr z,guiDrawButtonSmall
 set fracDrawLFont,(iy+fontFlags)
guiDrawButtonSmall:
 res textInverse,(iy+textFlags)
 bit BU_Inverse,(ix+4)
 jr z,guiDrawButtonNotInverse
 set textInverse,(iy+textFlags)
guiDrawButtonNotInverse:
 ld h,a
 ld (pencol),hl
 ld de,5
 push ix
 pop hl
 add hl,de
 call centertext2
 res textInverse,(iy+textflags)
 res fracDrawLFont,(iy+fontFlags)
 ret

guiEraseButton:
 bit BU_Inverse,(ix+4)
 jr nz,guiEraseBottomFill
 B_CALL _clearrect
 ret
guiEraseBottomFill:
 B_CALL _fillrect
 ret

guiHandleButton:
 ld c,(hl)
 inc hl
 ld b,(hl)
 inc hl
 ld a,(hl)
 inc hl
 push hl
 pop ix
 bit BU_Showing,(ix+1)
 ret z
 ld h,(hl)
 ld l,a
 add hl,bc
 call IsInRectangle
 ret c
 push bc
 ex de,hl
 pop hl
 push hl
 push de
 res plotLoc,(iy+plotflags)
 B_CALL _invertrect
guiHandleButtonLoop:
 ld a,0ffh
 out (1),a
 ld a,0fdh
 out (1),a
 in a,(1)
 bit 0,a
 jr z,guiHandleButtonLoop
 ld a,0bfh
 out (1),a
 in a,(1)
 bit 5,a
 jr z,guiHandleButtonLoop
 pop de
 pop hl
 B_CALL _invertrect
 jp guiHandleClickFinished
