; Mouse
; A controllable arrow-shaped cursor.
;
; Functions:
; 1. guiSetupMouse
; 2. guiHandleMouse
;
; Comments:
;  HeyHey! Somewhere down there is a routine for a masked clipped sprite
;   that displays only to the screen, and saves the stuff behind it!
;   (note that cliiping only works on the bottom and right...)
;

guiSetupMouse:
 xor a
 ld (guiMouseX),a
 ld (guiMouseY),a
 dec a
 ld (guiMouseKey),a
 ret

guiHandleMouse:
 call guiDrawMouse
 ei
 halt
 halt
 halt		; Delay a bit, so the cursor doesn't look too flashy
 call guiEraseMouse
 ld de,(guiMouseX)
 ld hl,guiMouseKey
 ld a,0FFh
 out (1),a
 ld a,0FEh
 out (1),a
 in a,(1)
 ld b,a
 bit 0,b
 call z,guiMouseDown
 bit 1,b
 call z,guiMouseLeft
 bit 2,b
 call z,guiMouseRight
 bit 3,b
 call z,guiMouseUp
 ld (guiMouseX),de
 ld a,b
 rra
 rr (hl)
 rra
 rr (hl)
 rra
 rr (hl)
 rra
 rr (hl)
 ld a,0BFh
 out (1),a
 in a,(1)
 bit 5,a
 jr z,guiMouseSelect
 ld a,0FDh
 out (1),a
 in a,(1)
 bit 0,a
 jr nz,guiHandleMouse
guiMouseSelect:
 ret
 
guiMouseDown:
 inc d
 bit 4,(hl)
 jr nz,guiMouseDownDone
 inc d
 inc d
 bit 0,(hl)
 jr nz,guiMouseDownDone
 inc d
 inc d
guiMouseDownDone:
 ld a,63
 cp d
 ret nc
 ld d,63
 ret

guiMouseUp:
 dec d
 bit 7,(hl)
 jr nz,guiMouseUpDone
 dec d
 dec d
 bit 3,(hl)
 jr nz,guiMouseUpDone
 dec d
 dec d
guiMouseUpDone:
 bit 7,d
 ret z
 ld d,0
 ret

guiMouseLeft:
 dec e
 bit 5,(hl)
 jr nz,guiMouseLeftDone
 dec e
 dec e
 bit 1,(hl)
 jr nz,guiMouseLeftDone
 dec e
 dec e
guiMouseLeftDone:
 bit 7,e
 ret z
 ld e,0
 ret

guiMouseRight:
 inc e
 bit 6,(hl)
 jr nz,guiMouseRightDone
 inc e
 inc e
 bit 2,(hl)
 jr nz,guiMouseRightDone
 inc e
 inc e
guiMouseRightDone:
 ld a,95
 cp e
 ret nc
 ld e,95
 ret

;guiDrawMouse:
; di
; ld ix,MouseSprite
; ld de,(guiMouseX)
; ld b,8
; ld a,b
; add a,d
; sub 64
; jr c,guiDrawMouseNoBottomClip
; neg
; add a,b
; ld b,a
;guiDrawMouseNoBottomClip:
; ld a,e
; ld e,d
; ld l,e
; ld d,0
; ld h,d
; add hl,de
; add hl,de
; add hl,hl
; add hl,hl
; ld e,a
; and 7
; srl e
; srl e
; srl e
; ld c,a
; ld a,e
; cp 11
; ld a,2
; jr nz,guiDrawMouseNoRightClip
; ld a,1
;guiDrawMouseNoRightClip:
; add hl,de
; ld de,plotsscreen
; add hl,de
; ld de,guiBkgd
;guiDrawMouseRowLoop:
; push af
; ex af,af'
; push bc
; ld a,(hl)
; ld (de),a
; inc hl
; inc de
; ld a,(hl)
; ld (de),a
; inc de
; dec hl
; push de
; ld a,c
; ld b,(ix)
; inc ix
; ld d,(ix)
; inc ix
; ld c,0
; ld e,0ffh
; or a
; jr z,guiDrawMouseSkipRotate
;guiDrawMouseRotateLoop:
; srl b
; rr c
; scf
; rr d
; rr e
; dec a
; jr nz,guiDrawMouseRotateLoop
;guiDrawMouseSkipRotate:
; ld a,(hl)
; and d
; or b
; ld (hl),a
; inc hl
; ex af,af'
; dec a
; push af
; ex af,af'
; pop af
; jr z,guiDrawMouseEndRight
; ld a,(hl)
; and e
; or c
; ld (hl),a
;guiDrawMouseEndRight:
; ld de,11
; add hl,de
; pop de
; pop bc
; pop af
; djnz guiDrawMouseRowLoop
; ret

;guiEraseMouse:
; ld ix,guiBkgd
; ld de,(guiMouseX)
; ld b,8
; ld a,b
; add a,d
; sub 64
; jr c,guiEraseMouseNoBottomClip
; neg
; add a,b
; ld b,a
;guiEraseMouseNoBottomClip:
; ld a,e
; ld e,d
; ld l,e
; ld d,0
; ld h,d
; add hl,de
; add hl,de
; add hl,hl
; add hl,hl
; ld e,a
; and 7
; srl e
; srl e
; srl e
; add hl,de
; ld de,plotsscreen
; add hl,de
; ld de,11
;guiEraseMouseLoop:
; ld a,(ix)
; ld (hl),a
; inc ix
; inc hl
; ld a,(ix)
; ld (hl),a
; inc ix
; add hl,de
; djnz guiEraseMouseLoop
; ret

; The masked mouse sprite...
MouseSprite:
 db 11111110b,11111111b
 db 10000100b,10000111b
 db 10001000b,10001111b
 db 10000100b,10000111b
 db 10100010b,10100011b
 db 11010001b,11110001b
 db 10001010b,11111011b
 db 00000100b,11111111b

guiDrawMouse:
 di
 ld de,(guiMouseX)
 res plotLoc,(iy+plotflags)	; Note that this has nothing to do with plotLoc, i'm simply
 				; using this flag because it's disposable... it tells if we
 				; are clipping the right hand side or not.
 ld hl,guiBkgd
 ld (guiBkgdPtr),hl		; this is a pointer to the place where we save what
 				; was under the arrow
 ld b,8		; row counter
 ld a,b
 add a,d
 sub 64
 jr c,guiDrawMouseNoBottomClip
 neg
 add a,b
 ld b,a
guiDrawMouseNoBottomClip:
 ld a,d
 cp 88
 jr c,guiDrawMouseNoRightClip
 set plotloc,(iy+plotflags)
guiDrawMouseNoRightClip:
 ld a,07h
 call lcdbusy
 out (10h),a	; y auto inc mode
 ld ix,MouseSprite
 ld a,d
guiDrawMouseNextRow:
 push af
 push bc
 push de
 or 80h
 call lcdbusy
 out (10h),a	; Set row
 ld a,e
 srl a
 srl a
 srl a
 or 20h
 call lcdbusy
 out (10h),a	; Set col
 call lcdbusy
 in a,(11h)	; dummy read
 ld bc,(guiBkgdPtr)
 call lcdbusy
 in a,(11h)	; real read
 ld h,a
 ld (bc),a	; save underneath
 inc bc
 bit plotloc,(iy+plotflags)
 jr nz,guiDrawMouseRC
 call lcdbusy
 in a,(11h)
 ld l,a		; current display bytes are in hl
 ld (bc),a
guiDrawMouseRC:
 inc bc
 ld (guiBkgdPtr),bc
 ld a,e
 and 7		; amount to shift the sprite
 ld b,(ix)
 ld c,0
 inc ix
 ld d,(ix)
 ld e,-1
 inc ix
 or a
 jr z,guiDrawMouseNoShift
guiDrawMouseShiftLoop:
 srl b
 rr c
 scf
 rr d
 rr e
 dec a
 jr nz,guiDrawMouseShiftLoop
guiDrawMouseNoShift:
 ld a,h
 and d
 or b
 ld h,a
 bit plotloc,(iy+plotflags)
 jr nz,guiDrawMouseRC2
 ld a,l
 and e
 or c
 ld l,a
guiDrawMouseRC2:
 pop de
 pop bc
 pop af
 push af
 or 80h
 call lcdbusy
 out (10h),a	; Set row
 ld a,e
 srl a
 srl a
 srl a
 or 20h
 call lcdbusy
 out (10h),a	; Set col
 ld a,h
 call lcdbusy
 out (11h),a
 bit plotloc,(iy+plotflags)
 jr nz,guiDrawMouseRC3
 ld a,l
 call lcdbusy
 out (11h),a
guiDrawMouseRC3:
 pop af
 inc a
 dec b
 jp nz,guiDrawMouseNextRow
 ld a,05h
 call lcdbusy
 out (10h),a	; x auto inc mode (for OS)
 ret
guiEraseMouse:
 di
 ld de,(guiMouseX)
 res plotLoc,(iy+plotflags)	; Note that this has nothing to do with plotLoc, i'm simply
 				; using this flag because it's disposable... it tells if we
 				; are clipping the right hand side or not.
 ld ix,guiBkgd
 ld b,8		; row counter
 ld a,b
 add a,d
 sub 64
 jr c,guiEraseMouseNoBottomClip
 neg
 add a,b
 ld b,a
guiEraseMouseNoBottomClip:
 ld a,d
 cp 88
 jr c,guiEraseMouseNoRightClip
 set plotloc,(iy+plotflags)
guiEraseMouseNoRightClip:
 ld a,07h
 call lcdbusy
 out (10h),a	; y auto inc mode
 ld a,d
guiEraseMouseNextRow:
 push af
 push bc
 push de
 or 80h
 call lcdbusy
 out (10h),a	; Set row
 ld a,e
 srl a
 srl a
 srl a
 or 20h
 call lcdbusy
 out (10h),a	; Set col
 ld a,(ix)
 inc ix
 call lcdbusy
 out (11h),a
 bit plotloc,(iy+plotflags)
 jr nz,guiEraseMouseRC
 ld a,(ix)
 call lcdbusy
 out (11h),a
guiEraseMouseRC:
 inc ix
 pop de
 pop bc
 pop af
 inc a
 djnz guiEraseMouseNextRow
 ld a,05h
 call lcdbusy
 out (10h),a
 ret
 
lcdbusy:
 push af
 inc hl
 dec hl
 pop af
 ret